diff --git a/rust/capnp/any_pointer.rs b/rust/capnp/any_pointer.rs
index c49216cd031e..83ae07a20a09 100644
--- a/rust/capnp/any_pointer.rs
+++ b/rust/capnp/any_pointer.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/any_pointer_list.rs b/rust/capnp/any_pointer_list.rs
index 1c4e9e40c879..f7f4fae5678c 100644
--- a/rust/capnp/any_pointer_list.rs
+++ b/rust/capnp/any_pointer_list.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2018 the capnproto-rust contributors
 //
 // Permission is hereby granted, free of charge, to any person obtaining a copy
diff --git a/rust/capnp/capability.rs b/rust/capnp/capability.rs
index 7cff20bbbcb9..fbe778791c38 100644
--- a/rust/capnp/capability.rs
+++ b/rust/capnp/capability.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/capability_list.rs b/rust/capnp/capability_list.rs
index 083794e073d1..b139d566a58d 100644
--- a/rust/capnp/capability_list.rs
+++ b/rust/capnp/capability_list.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2017 David Renshaw and contributors
 //
 // Permission is hereby granted, free of charge, to any person obtaining a copy
diff --git a/rust/capnp/constant.rs b/rust/capnp/constant.rs
index fdd1edf487ff..9f174366d89d 100644
--- a/rust/capnp/constant.rs
+++ b/rust/capnp/constant.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2017 Sandstorm Development Group, Inc. and contributors
 //
 // Permission is hereby granted, free of charge, to any person obtaining a copy
diff --git a/rust/capnp/data.rs b/rust/capnp/data.rs
index 89e0c6c19ea4..d777f1d626b0 100644
--- a/rust/capnp/data.rs
+++ b/rust/capnp/data.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/data_list.rs b/rust/capnp/data_list.rs
index f5fee2575fd2..7771ea4bb04d 100644
--- a/rust/capnp/data_list.rs
+++ b/rust/capnp/data_list.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/dynamic_list.rs b/rust/capnp/dynamic_list.rs
index f2c93e1cbe16..0b60674cdeab 100644
--- a/rust/capnp/dynamic_list.rs
+++ b/rust/capnp/dynamic_list.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 //! Dynamically-typed lists.
 
 use crate::dynamic_value;
diff --git a/rust/capnp/dynamic_struct.rs b/rust/capnp/dynamic_struct.rs
index d0244fc29f40..9da5a1e5df33 100644
--- a/rust/capnp/dynamic_struct.rs
+++ b/rust/capnp/dynamic_struct.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 //! Dynamically-typed structs.
 
 use crate::introspect::TypeVariant;
diff --git a/rust/capnp/dynamic_value.rs b/rust/capnp/dynamic_value.rs
index 83646e26de31..aaca4d82453f 100644
--- a/rust/capnp/dynamic_value.rs
+++ b/rust/capnp/dynamic_value.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 //! Dynamically typed values.
 
 use crate::introspect::{self, TypeVariant};
diff --git a/rust/capnp/enum_list.rs b/rust/capnp/enum_list.rs
index 8fa713029250..0192732fe16b 100644
--- a/rust/capnp/enum_list.rs
+++ b/rust/capnp/enum_list.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/introspect.rs b/rust/capnp/introspect.rs
index d994b180c93a..a3494935b4d5 100644
--- a/rust/capnp/introspect.rs
+++ b/rust/capnp/introspect.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 //! Traits and types to support run-time type introspection, i.e. reflection.
 
 use crate::private::layout::ElementSize;
diff --git a/rust/capnp/io.rs b/rust/capnp/io.rs
index 59d149b37c26..82c429f8c263 100644
--- a/rust/capnp/io.rs
+++ b/rust/capnp/io.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 //! Custom I/O traits that roughly mirror `std::io::{Read, BufRead, Write}`.
 //! This extra layer of indirection enables support of no-std environments.
 
diff --git a/rust/capnp/lib.rs b/rust/capnp/lib.rs
index daafc23c19d5..d3aa0f9f3451 100644
--- a/rust/capnp/lib.rs
+++ b/rust/capnp/lib.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/list_list.rs b/rust/capnp/list_list.rs
index 7c31560958d3..ec7e830df7e1 100644
--- a/rust/capnp/list_list.rs
+++ b/rust/capnp/list_list.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/message.rs b/rust/capnp/message.rs
index fe40e0a7c313..595f6975c489 100644
--- a/rust/capnp/message.rs
+++ b/rust/capnp/message.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/primitive_list.rs b/rust/capnp/primitive_list.rs
index 4ea31a7b50eb..a761320788b5 100644
--- a/rust/capnp/primitive_list.rs
+++ b/rust/capnp/primitive_list.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/private/arena.rs b/rust/capnp/private/arena.rs
index 46626c1f0ce3..40c539d72142 100644
--- a/rust/capnp/private/arena.rs
+++ b/rust/capnp/private/arena.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2017 Sandstorm Development Group, Inc. and contributors
 //
 // Permission is hereby granted, free of charge, to any person obtaining a copy
diff --git a/rust/capnp/private/capability.rs b/rust/capnp/private/capability.rs
index ba725fb60535..522d0b1b0418 100644
--- a/rust/capnp/private/capability.rs
+++ b/rust/capnp/private/capability.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/private/layout.rs b/rust/capnp/private/layout.rs
index 02ecb6e7bfb5..dbfe97235cd9 100644
--- a/rust/capnp/private/layout.rs
+++ b/rust/capnp/private/layout.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/private/layout_test.rs b/rust/capnp/private/layout_test.rs
index 8715e9edab43..fb5a8de9bb44 100644
--- a/rust/capnp/private/layout_test.rs
+++ b/rust/capnp/private/layout_test.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/private/mask.rs b/rust/capnp/private/mask.rs
index dfa211521ca7..70937b802bf6 100644
--- a/rust/capnp/private/mask.rs
+++ b/rust/capnp/private/mask.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/private/mod.rs b/rust/capnp/private/mod.rs
index 1e6bcdab6d6e..2126235199fe 100644
--- a/rust/capnp/private/mod.rs
+++ b/rust/capnp/private/mod.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/private/primitive.rs b/rust/capnp/private/primitive.rs
index 00e41ce40f08..f70f3a7486f3 100644
--- a/rust/capnp/private/primitive.rs
+++ b/rust/capnp/private/primitive.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 pub trait Primitive {
     type Raw;
 
diff --git a/rust/capnp/private/read_limiter.rs b/rust/capnp/private/read_limiter.rs
index 0bb6a7a8415c..f4f0cf348af1 100644
--- a/rust/capnp/private/read_limiter.rs
+++ b/rust/capnp/private/read_limiter.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/private/units.rs b/rust/capnp/private/units.rs
index 90fbf663f777..37782edeef56 100644
--- a/rust/capnp/private/units.rs
+++ b/rust/capnp/private/units.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/private/zero.rs b/rust/capnp/private/zero.rs
index 00769cfebafc..12e4a723105a 100644
--- a/rust/capnp/private/zero.rs
+++ b/rust/capnp/private/zero.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/raw.rs b/rust/capnp/raw.rs
index 5883b1207be9..3127b6adc0fc 100644
--- a/rust/capnp/raw.rs
+++ b/rust/capnp/raw.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2018 the capnproto-rust contributors
 //
 // Permission is hereby granted, free of charge, to any person obtaining a copy
diff --git a/rust/capnp/schema.rs b/rust/capnp/schema.rs
index 4120868f4051..b7677056cc10 100644
--- a/rust/capnp/schema.rs
+++ b/rust/capnp/schema.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 //! Convenience wrappers of the datatypes defined in schema.capnp.
 
 use crate::dynamic_value;
diff --git a/rust/capnp/schema_capnp.rs b/rust/capnp/schema_capnp.rs
index 4f92ee288821..820a1187bf59 100644
--- a/rust/capnp/schema_capnp.rs
+++ b/rust/capnp/schema_capnp.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // @generated by the capnpc-rust plugin to the Cap'n Proto schema compiler.
 // DO NOT EDIT.
 // source: schema.capnp
diff --git a/rust/capnp/serialize.rs b/rust/capnp/serialize.rs
index ad9e130e5ed7..025bcd45ee61 100644
--- a/rust/capnp/serialize.rs
+++ b/rust/capnp/serialize.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/serialize/no_alloc_buffer_segments.rs b/rust/capnp/serialize/no_alloc_buffer_segments.rs
index d3837738d702..de902a0ee4d4 100644
--- a/rust/capnp/serialize/no_alloc_buffer_segments.rs
+++ b/rust/capnp/serialize/no_alloc_buffer_segments.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 use core::convert::TryInto;
 
 use crate::message::ReaderOptions;
diff --git a/rust/capnp/serialize_packed.rs b/rust/capnp/serialize_packed.rs
index 286a36950981..63ed7264848e 100644
--- a/rust/capnp/serialize_packed.rs
+++ b/rust/capnp/serialize_packed.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/stringify.rs b/rust/capnp/stringify.rs
index d11bfbeb7b14..426025fea0e8 100644
--- a/rust/capnp/stringify.rs
+++ b/rust/capnp/stringify.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 use crate::dynamic_value;
 use core::fmt::{self, Formatter};
 
diff --git a/rust/capnp/struct_list.rs b/rust/capnp/struct_list.rs
index 5c2775ddc1fd..7133e69560bc 100644
--- a/rust/capnp/struct_list.rs
+++ b/rust/capnp/struct_list.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/text.rs b/rust/capnp/text.rs
index fa2a72701444..406ddb5ba8ac 100644
--- a/rust/capnp/text.rs
+++ b/rust/capnp/text.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/text_list.rs b/rust/capnp/text_list.rs
index 72cbd2647ba9..222521a6741e 100644
--- a/rust/capnp/text_list.rs
+++ b/rust/capnp/text_list.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //
diff --git a/rust/capnp/traits.rs b/rust/capnp/traits.rs
index 39e050ab4abf..e12c38346d56 100644
--- a/rust/capnp/traits.rs
+++ b/rust/capnp/traits.rs
@@ -1,3 +1,5 @@
+// SPDX-License-Identifier: MIT
+
 // Copyright (c) 2013-2015 Sandstorm Development Group, Inc. and contributors
 // Licensed under the MIT License:
 //